//-*-c++-*------------------------------------------------------------
//
// File name : bioArithAbs.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue May  5 10:53:11 2009
//
//--------------------------------------------------------------------

#ifndef bioArithAbs_h
#define bioArithAbs_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing an absolute value operation
*/
class bioArithAbs : public bioExpression {

public:
  
  bioArithAbs(bioExpression* par,
		          bioExpression* left) ;
  ~bioArithAbs() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, patError*& err) const ;
  virtual bioArithAbs* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getExpressionString() const ;
};

#endif
