//-*-c++-*------------------------------------------------------------
//
// File name : bioArithBinaryMinus.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue Apr 28 20:25:55 2009
//
//--------------------------------------------------------------------

#ifndef bioArithBinaryMinus_h
#define bioArithBinaryMinus_h


#include "bioExpression.h"

/*!
Class implementing a node for a soustraction operation
*/
class bioArithBinaryMinus : public bioExpression {

public:
  
  bioArithBinaryMinus(bioExpression* par,
		                 bioExpression* left, 
		                 bioExpression* right) ;
  ~bioArithBinaryMinus() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, patError*& err) const ;
  virtual bioArithBinaryMinus* getDeepCopy(patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getExpressionString() const ;
};

#endif
