//-*-c++-*------------------------------------------------------------
//
// File name : bioArithBinaryPlus.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue Apr 28 15:11:56 2009
//
//--------------------------------------------------------------------

#ifndef bioArithBinaryPlus_h
#define bioArithBinaryPlus_h


#include "bioExpression.h"

/*!
Class implementing a node for an addition operation
*/
class bioArithBinaryPlus : public bioExpression {

public:
  
  bioArithBinaryPlus(bioExpression* par,
		     bioExpression* left, 
		     bioExpression* right) ;
  ~bioArithBinaryPlus() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, 
				       patError*& err) const ;
  virtual bioArithBinaryPlus* getDeepCopy(patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getExpression(patError*& err) const ;
  virtual patString getExpressionString() const ;
};

#endif
