//-*-c++-*------------------------------------------------------------
//
// File name : bioArithConstant.cc
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Wed May  6 16:36:58 2009
//
//--------------------------------------------------------------------

#include <sstream>
#include "bioArithConstant.h"

bioArithConstant::bioArithConstant(bioExpression* par,
				   patReal aValue) : 
  bioExpression(par,NULL,NULL),
  theValue(aValue) {

}
  
bioExpression::bioOperatorType bioArithConstant::getOperatorType() const {
  return CONSTANT_OP ;
}

patString bioArithConstant::getOperatorName() const {
  stringstream str ;
  str << theValue ;
  return patString(str.str()) ; 
}

patReal bioArithConstant::getValue(patError*& err) const {
  return theValue ;
}

bioExpression* bioArithConstant::getDerivative(patULong aLiteralId, 
					       patError*& err) const {
  bioExpression* result = new bioArithConstant(NULL,0) ;
  return result ;
}

bioExpression* bioArithConstant::getDeepCopy(patError*& err) {
  bioArithConstant* theNode = new bioArithConstant(NULL,theValue) ;
  theNode->leftChild = NULL ;
  theNode->rightChild = NULL ;
  return theNode ;
}

patString bioArithConstant::getCppCode(patString prefix, patError*& err) {
  if (codeMustBeGenerated) {
  stringstream str ;
  str << getCppResultDeclaration(prefix) << " = " ;
  str << theValue ;
  str << " ;" << endl ;
  //  str << "DEBUG_MESSAGE(\"" << getCppResult(prefix) << "= \" << " << getCppResult(prefix) << ");" << endl ;
  codeMustBeGenerated = patFALSE ;
  return patString(str.str()) ; 
  }
  else {
    return patString() ;
  }
}


patString bioArithConstant::getSimpleCppCode(patError*& err) {
  stringstream str ;
  str << theValue ;
  return patString(str.str()) ; 
}


patBoolean bioArithConstant::isStructurallyZero() const {
  return (theValue == 0) ;
}

patBoolean bioArithConstant::isConstant() const {
  return patTRUE ;
}

patULong bioArithConstant::getNumberOfOperations() const {
  return 0 ;
}

patString bioArithConstant::getExpressionString() const {
  stringstream str ;
  str << theValue ;
  return patString(str.str()) ;

}
