//-*-c++-*------------------------------------------------------------
//
// File name : bioArithDerivative.h
// Author :    Michel Bierlaire
// Date :      Tue May 11 06:06:10 2010
//
//--------------------------------------------------------------------

#ifndef bioArithDerivative_h
#define bioArithDerivative_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing the derivative of the expression with respect to a literal
*/
class bioArithDerivative : public bioExpression {

public:
  
  bioArithDerivative(bioExpression* par,
		   bioExpression* left,
		   patString aLiteralName,
		   patError*& err) ;
  
  ~bioArithDerivative() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, 
				       patError*& err) const ;
  virtual bioArithDerivative* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual void generateGslFunctions(ostream& str_h,patString prefix,patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patBoolean isStructurallyZero() const ;
  virtual patString getExpressionString() const ;
public:
  patULong literalId ;
  patString literalName ;
  bioExpression* theDerivative ;

};

#endif
