//-*-c++-*------------------------------------------------------------
//
// File name : bioArithElem.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue Jul 14 10:32:08  2009
//
//--------------------------------------------------------------------

#ifndef bioArithElem_h
#define bioArithElem_h


#include "bioExpression.h"

/*!

*/
class bioArithElem : public bioExpression {

public:
  
  bioArithElem(bioExpression* par,
	       bioExpression* left,
	       map<patULong,bioExpression*> aDict,
	       bioExpression* def) ;
  ~bioArithElem() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, patError*& err) const ;
  virtual bioArithElem* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getExpression(patError*& err) const ;
  virtual patBoolean isSimple() const ;
  virtual patBoolean dependsOf(patULong aLiteralId) const ;
  virtual void forceCodeGeneration() ;
  virtual void simplifyZeros(patError*& err) ;
  virtual patULong getNumberOfOperations() const ;
  patULong lastIndex() const ;
  patULong countExpressions(map<patString,patULong>* theExpressions, 
			    map<patString,list<patULong> >* theIds,
			    map<patString,list<bioExpression*> >* thePointers,
			    patError*& err)  ; 

  virtual bioExpression* getExpressionFromId(patULong theId) ;
  virtual void replaceExpression(bioExpression* theExpression, 
				 bioExpression* anotherExpression, 
				 patError*& err) ;
  virtual patString getExpressionString() const ;
  virtual void getExpressionsToSimplify(vector<bioExpression*>* theExpr, 
					patError*& err) ;
  patBoolean containsAnIntegral() const ;
  patBoolean containsAnIterator() const ;
  patBoolean containsASequence() const ;
  void generateGslFunctions(ostream& str_h,patString prefix,patError*& err) ;

private:
  bioExpression* defaultExpression ;
  map<patULong,bioExpression*> theDictionary ;
  patString variableWhereStored ;
  
};

#endif
