//-*-c++-*------------------------------------------------------------
//
// File name : bioArithGreaterEqual.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue May  5 11:31:26 2009
//
//--------------------------------------------------------------------

#ifndef bioArithGreaterEqual_h
#define bioArithGreaterEqual_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing a comparison (>=) operation
*/
class bioArithGreaterEqual : public bioExpression {

public:
  
  bioArithGreaterEqual(bioExpression* par,
		            bioExpression* left,
		            bioExpression* right) ;
  ~bioArithGreaterEqual() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, patError*& err) const ;
  virtual bioArithGreaterEqual* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getExpressionString() const ;
};

#endif
