//-*-c++-*------------------------------------------------------------
//
// File name : bioArithIntegral.h
// Author :    Michel Bierlaire
// Date :      Tue Mar 30 17:33:52 2010
//
//--------------------------------------------------------------------

#ifndef bioArithIntegral_h
#define bioArithIntegral_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing an integral between -infty and +infty
*/
class bioArithIntegral : public bioExpression {

public:
  
  bioArithIntegral(bioExpression* par,
		   bioExpression* left,
		   patString aLiteralName,
		   patError*& err) ;
  
  ~bioArithIntegral() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, 
				       patError*& err) const ;
  virtual bioArithIntegral* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patBoolean isStructurallyZero() const ;
  virtual patString getExpressionString() const ;
  virtual void generateGslFunctions(ostream& str_h, patString prefix, patError*& err) ;
public:
  patULong literalId ;
  patString literalName ;

};

#endif
