//-*-c++-*------------------------------------------------------------
//
// File name : bioArithLessEqual.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue May  5 11:34:15 2009
//
//--------------------------------------------------------------------

#ifndef bioArithLessEqual_h
#define bioArithLessEqual_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing a comparison (<=) operation
*/
class bioArithLessEqual : public bioExpression {

public:
  
  bioArithLessEqual(bioExpression* par,
		                bioExpression* left,
		                bioExpression* right) ;
  ~bioArithLessEqual() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId,
				       patError*& err) const ;
  virtual bioArithLessEqual* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getExpressionString() const ;
};

#endif
