//-*-c++-*------------------------------------------------------------
//
// File name : bioArithLiteral.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Mon Apr 27 17:19:08 2009
//
//--------------------------------------------------------------------

#ifndef bioArithLiteral_h
#define bioArithLiteral_h

#include "bioExpression.h"
#include "bioLiteral.h"

/*!
Class implementing the node for literals in an expression
*/

class bioArithLiteral: public bioExpression {

public:
  bioArithLiteral(bioExpression* par, patULong aLiteralId) ;
  
 public:
  
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const ;
  virtual patReal getValue(patError*& err) const ;
  virtual bioExpression* getDerivative(patULong aLiteralId, patError*& err) const ;
  virtual bioExpression* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getExpression(patError*& err) const ;
  virtual patBoolean dependsOf(patULong aLiteralId) const ;
  virtual patULong getNumberOfOperations() const ;
  virtual patString getExpressionString() const  ;
  
 protected:

  patULong theLiteralId ;
  patString theName ;

};

#endif
