//-*-c++-*------------------------------------------------------------
//
// File name : bioArithLog.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue May  5 14:01:16 2009
//
//--------------------------------------------------------------------

#ifndef bioArithLog_h
#define bioArithLog_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing a natural logarithm operation
*/
class bioArithLog : public bioExpression {

public:
  
  bioArithLog(bioExpression* par,
		          bioExpression* left) ;
  ~bioArithLog() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteral, patError*& err) const ;
  virtual bioArithLog* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patBoolean isSimple() const ;
  virtual patString getExpressionString() const ;
};

#endif
