//-*-c++-*------------------------------------------------------------
//
// File name : bioArithNormalCdf.h
// Author :    Michel Bierlaire
// Date :      Tue Jun  8 17:59:01 2010
//
//--------------------------------------------------------------------

#ifndef bioArithNormalCdf_h
#define bioArithNormalCdf_h


#include "bioExpression.h"
#include "patNormalCdf.h"

/*!
Class implementing a node of the tree representing the CDF of the normal distribution
*/
class bioArithNormalCdf : public bioExpression {

public:
  
  bioArithNormalCdf(bioExpression* par,
		          bioExpression* left) ;
  ~bioArithNormalCdf() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteral, patError*& err) const ;
  virtual bioArithNormalCdf* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patBoolean isSimple() const ;
  virtual patString getExpressionString() const ;
};

#endif
