//-*-c++-*------------------------------------------------------------
//
// File name : bioArithPower.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue May 5  12:05:41 2009
//
//--------------------------------------------------------------------

#ifndef bioArithPower_h
#define bioArithPower_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing a power operation
*/
class bioArithPower : public bioExpression {

public:
  
  bioArithPower(bioExpression* par,
		            bioExpression* left,
                bioExpression* right) ;

  ~bioArithPower() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, 
				       patError*& err) const ;
  virtual bioArithPower* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patBoolean isStructurallyZero() const ;
  virtual patString getExpressionString() const ;
};

#endif
