//-*-c++-*------------------------------------------------------------
//
// File name : bioArithUnaryMinus.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Fri May 15 09:38:34 2009
//
//--------------------------------------------------------------------

#ifndef bioArithUnaryMinus_h
#define bioArithUnaryMinus_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing a unary minus operation
*/
class bioArithUnaryMinus : public bioExpression {

public:
  
  bioArithUnaryMinus(bioExpression* par,
                     bioExpression* left) ;
  ~bioArithUnaryMinus() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, 
				       patError*& err) const ;
  virtual bioArithUnaryMinus* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getExpressionString() const ;
};

#endif
