//-*-c++-*------------------------------------------------------------
//
// File name : bioGenerateLikelihoodFunction.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Fri Jul 17 10:09:11 2009
//
//--------------------------------------------------------------------

#ifndef bioGenerateLikelihoodFunction_h
#define bioGenerateLikelihoodFunction_h

#include <map>
#include "patType.h"
#include "patString.h"
#include "patError.h"

class bioExpression ;
class bioGenerateLikelihoodFunction {

public:
  bioGenerateLikelihoodFunction(map<patString,patULong>* lit, 
				bioExpression* anExpression,
				map<patString,bioExpression*>* constraints,
				patString m, patString f, patString g) ;
  void generate(patError*& err) ;
  void writeHeaders(ofstream& f,patError*& err) ;
 private:
  bioExpression* theExpression ;
  map<patString,bioExpression*>* theConstraints ;
  patString mainFileName ;
  patString fctFileName ;
  patString gradFileName ;
  map<patString,patULong>* literals ;
};
#endif
