//-*-c++-*------------------------------------------------------------
//
// File name : bioModel.cc
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Thu May  7 13:36:48 WEST 2009
//
//--------------------------------------------------------------------

#include "bioModel.h"
#include "bioArithLiteral.h"
#include "patDisplay.h"

bioModel::bioModel(): theFormula(NULL), 
		      statistics(NULL), 
		      constraints(NULL), 
		      simulation(NULL) ,
		      excludeExpr(NULL) {
}

void bioModel::setFormula(bioExpression* f) {
  theFormula = f;
}

bioExpression* bioModel::getFormula() {
  return theFormula ;
}

void bioModel::setExcludeExpr(bioExpression* e) {
  excludeExpr = e;
}

bioExpression* bioModel::getExcludeExpr() {
  return excludeExpr ;
}

void bioModel::setStatistics(map<patString, bioExpression*>* stat) {
  statistics = stat ;
}
 
void bioModel::setConstraints(map<patString, bioExpression*>* constr) {
  constraints = constr ;
}

void bioModel::setSimulation(bioExpression* simul) {
  simulation = simul ;
}

map<patString, bioExpression*>* bioModel::getStatistics() {
  return statistics ;
}

map<patString, bioExpression*>* bioModel::getConstraints() {
  return constraints ;
}

bioExpression* bioModel::getSimulation() {
  return simulation ;
}


patBoolean bioModel::mustEstimate() const {
  patError* err(NULL) ;
  if (theFormula == NULL) {
    return patFALSE ;
  }
  if (theFormula->getExpression(err) == "0") {
    return patFALSE ;
  }
  if (err != NULL) {
    return patFALSE ;
  }
  return patTRUE  ;
}

patBoolean bioModel::mustSimulate() const {
  return (simulation != NULL) ;
}

