//-*-c++-*------------------------------------------------------------
//
// File name : bioRepositoryIteratorInfo.cc
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue Jul 14 13:25:19 2009
//
//--------------------------------------------------------------------

#include <sstream>
#include "patDisplay.h"
#include "bioRepositoryIteratorInfo.h"

bioRepositoryIteratorInfo* bioRepositoryIteratorInfo::the() {
  static bioRepositoryIteratorInfo* singleInstance = NULL ;
  if (singleInstance == NULL) {
    singleInstance = new bioRepositoryIteratorInfo ;
  }
  return singleInstance ;
}

void bioRepositoryIteratorInfo::addIteratorInfo(patString name, 
						bioIteratorInfo ii) {
  ii.iteratorName = name ;
  pair<patString,bioIteratorInfo> p(name,ii) ;
  theRepository.insert(p) ;
}

bioIteratorInfo* bioRepositoryIteratorInfo::getIteratorInfo(patString name) {
  map<patString,bioIteratorInfo>::iterator found = theRepository.find(name) ;
  if (found == theRepository.end()) {
    return NULL ;
  }
  return &(found->second) ;
}


bioRepositoryIteratorInfo::bioRepositoryIteratorInfo() {
}

patString bioRepositoryIteratorInfo::debug(patError*& err) {
  stringstream str ;
  str << "List of iterators" << endl ;
  for (map<patString,bioIteratorInfo>::iterator i = theRepository.begin() ;
       i != theRepository.end() ;
       ++i) {
    str << i->second << endl ;
    if (err != NULL) {
      WARNING(err->describe()) ;
      return patString() ;
    }
  }
  str << "List if types" << endl ;
  for (map<patString,bioIteratorInfo>::iterator i = theRepository.begin() ;
       i != theRepository.end() ;
       ++i) {
    str << i->first << ": " << i->second.getCppType(err) << endl ;
    if (err != NULL) {
      WARNING(err->describe()) ;
      return patString() ;
    }
  }
  return patString(str.str()) ;
}

