from biogeme import *
def logit_av(V,availability,choice) :
    chosen = Elem(V,choice)
    den = 0
    for i,v in V.items() :
        den += availability[i] * exp(v-chosen)

    a = Elem(availability,choice)
    P = a / den 
    return P

def logit_av_scale(V,availability,choice,group,scale) :
    s = Elem(scale,group)
    chosen = Elem(V,choice)
    den = 0
    for i,v in V.items() :
        den += availability[i] * exp(s * (v-chosen))

    a = Elem(availability,choice)
    P = a / den 
    return P

def logit(V,choice) :
    chosen = Elem(V,choice)
    den = 0
    for i,v in V.items() :
        den += exp(v-chosen)
    P = 1.0 / den 
    return P

def logit_scale(V,choice,group,scale) :
    s = Elem(scale,group)
    chosen = Elem(V,choice)
    den = 0
    for i,v in V.items() :
        den += exp(s * (v-chosen))
    P = 1.0 / den 
    return P


# The following formula computes the log of the probability. It is not
# valid if the chosen alternative happens to be unavailable.
def loglogit_av(V,availability,choice) :
    chosen = Elem(V,choice)
    den = 0
    for i,v in V.items() :
        den += availability[i] * exp(v-chosen)
    logP = -log(den)
    return logP

def loglogit(V,choice) :
    chosen = Elem(V,choice)
    den = 0
    for i,v in V.items() :
        den += exp(v-chosen)
    logP = -log(den)
    return logP

    
