from biogeme import *
def mev(V,Gi,choice) :
    den = 0
    for i,v in V.items() :
        den += Gi[i] * exp(v)

    P = Elem(Gi,choice) * exp(Elem(V,choice)) / den 
            
    return P

def mev_selectionBias(V,Gi,correction,choice) :
    den = 0
    for i,v in V.items() :
        den += exp(correction[i]) * Gi[i] * exp(v)

    P = exp(Elem(correction,choice)) * Elem(Gi,choice) * exp(Elem(V,choice)) / den 
            
    return P

# This implementation assumes that the Gi have been computed with the
# shifted utilities, that is V-V(chosen). Therefore, the shifted
# utilities must be used here as well. This is important to avoid
# numerical issues.

def mev_shifted(V,Gi,choice) :
    den = 0
    chosen = Elem(V,choice)
    for i,v in V.items() :
        den += Gi[i] * exp(v-chosen)

    P = Elem(Gi,choice) / den 
            
    return P


def mev_selectionBias_shifted(V,Gi,correction,choice) :
    den = 0
    chosen = Elem(V,choice)
    for i,v in V.items() :
        den += Gi[i] * exp(v-chosen + correction[i])

    P = exp(Elem(correction,choice)) * Elem(Gi,choice) / den 
            
    return P



    
